<template>
  <Button
    icon="pi pi-id-card"
    iconPos="left"
    label="Créer un compte patient"
    class="p-button-primary"
    @click="visible = true"
  />
  <Dialog v-model:visible="visible">
    <template #header>
      <h3>Création d'un nouveau compte patient</h3>
    </template>

    <div>
      <Image src="/avatar.png" alt="Mascotte" width="100" />
      <h5 :class="validateClass">Tous les champs doivent être remplis</h5>
      <div class="flex flex-direction-row">
        <div>
          <h5 for="name">Nom</h5>
          <InputText id="name" type="text" v-model="name" :class="nameClass" />
        </div>
        <div>
          <h5 for="surname">Prénom</h5>
          <InputText
            id="surname"
            type="text"
            v-model="surname"
            :class="surnameClass"
          />
        </div>
      </div>
      <div class="flex flex-direction-row">
        <div>
          <h5 for="login">Identifiant</h5>
          <InputText id="login" type="text" v-model="login" :class="loginClass" />
        </div>
        <div>
          <h5 for="password">Mot de passe</h5>
          <InputText
            id="password"
            type="text"
            v-model="password"
            :class="passwordClass"
          />
        </div>
      </div>
      <h5 for="naissance">Date de naissance</h5>
      <Calendar id="naissance" dateFormat="dd/mm/yy" v-model="naissance" :class="naissanceClass" />
      <h5 for="niveau">Niveau scolaire</h5>
      <InputText
        id="niveau"
        type="text"
        v-model="niveau"
        :class="niveauClass"
      />

      <p class="form-error" v-if="formError">{{ formError }}</p>
    </div>

    <template #footer>
      <Button
        :loading="formLoading"
        label="Créer"
        class="p-button-primary"
        @click="handleCreatePatientAccount"
      />
    </template>
  </Dialog>
</template>

<script>
import Button from "primevue/button";
import Dialog from "primevue/dialog";
import Image from "primevue/image";
import InputText from "primevue/inputtext";
import Calendar from "primevue/calendar";

import axios from 'axios';

export default {
  name: "Create Patient Account Page",
  components: {
    Button,
    Dialog,
    Image,
    InputText,
    Calendar,
  },
  data() {
    return {
      visible: false,
      name: "",
      surname: "",
      naissance: "",
      niveau: "",
      login: "",
      password: "",
      validateClass: "validate-form",
      nameClass: "validate-name",
      surnameClass: "validate-surname",
      naissanceClass: "validate-naissance",
      niveauClass: "validate-niveau",
      loginClass: 'validate-niveau',
      passwordClass: 'validate-niveau',
      formLoading: false,
      formError: null
    };
  },
  methods: {
    uid() {
      return (performance.now().toString(36)+Math.random().toString(36)).replace(/\./g,"");
    },
    async handleCreatePatientAccount() {
      this.formLoading = true
      this.formError = null
      if (
        this.name === "" ||
        this.surname === "" ||
        this.naissance === "" ||
        this.niveau === "" ||
        this.login === "" ||
        this.password === ""
      ) {
        this.formLoading = false
        this.validateClass = "non-validate-form";
        this.name === ""
          ? (this.nameClass = "non-validate-name")
          : (this.nameClass = "validate-name");
        this.surname === ""
          ? (this.surnameClass = "non-validate-surname")
          : (this.surnameClass = "validate-surname");
        this.naissance === ""
          ? (this.naissanceClass = "non-validate-naissance")
          : (this.naissanceClass = "validate-naissance");
        this.niveau === ""
          ? (this.niveauClass = "non-validate-niveau")
          : (this.niveauClass = "validate-niveau");
        this.login === "" ? (this.loginClass = "non-validate-niveau") : (this.loginClass = "validate-niveau")
        this.password === "" ? (this.passwordClass = "non-validate-niveau") : (this.passwordClass = "validate-niveau")
      } else {
        await axios.put("/enfants/create", {
          login: String(this.login), 
          nom: String(this.name), 
          prenom: String(this.surname), 
          date_naissance: String(new Date(this.naissance).toISOString().split('T')[0]), 
          classe: String(this.niveau),
          isWorking: false,
          work: 0,
          description: String(""),
          nb_etoile: 0,
          id_ortho: this.$store.state.user.id, 
          password: String(this.password),
        }).then((res) => {
          axios.put("/enfants/create/game", {
            gender: 1,
            ethnicity: 1,
            instructions: "",
            horiz: false,
            equipedItems: "",
            locked_goose_easy: false,
            locked_goose_medium: true,
            locked_goose_hard: true,
            locked_listen_choose_easy: false,
            locked_listen_choose_medium: true,
            locked_listen_choose_hard: true,
            locked_memories_easy: false,
            locked_memories_medium: true,
            locked_memories_hard: true,
            id_enfant: res.data.id
          }).then(res => {
            console.log('Success')
          }).catch(err => {
            console.log(err)
          })
          this.$store.commit('addNewPatient', {patient: res.data})
          this.name = "";
          this.login = "";
          this.password = "";
          this.surname = "";
          this.naissance = "";
          this.niveau = "";
          this.validateClass = "validate-form";
          this.nameClass = "validate-name";
          this.surnameClass = "validate-surname";
          this.naissanceClass = "validate-naissance";
          this.niveauClass = "validate-niveau";
          this.loginClass = "validate-niveau";
          this.passwordClass = "validate-niveau"; 
          this.visible = false;
          this.formLoading = false
          })
        .catch(error => {
          if ('detail' in error.response.data && error.response.data.detail == "Login already used") {
            this.formLoading = false
            this.formError = "L'identifiant est déjà utilisé par quelqu'un d'autre"
          } else {
            this.formLoading = false
            this.formError = "Une erreur est survenue"
            alert(JSON.stringify(error))
            console.error(error);
          }
        });;
      }
    },
  },
};
</script>

<style lang="scss">
.form-error {
  color: red;
  font-size: 14px
}

.validate-form {
  display: none;
}

.non-validate-form {
  color: red;
  padding-bottom: 0.5rem;
}

.non-validate-name {
  border-color: red !important;
}

.non-validate-surname {
  border-color: red !important;
}

.non-validate-naissance > input {
  border-color: red;
}

.non-validate-niveau {
  border-color: red !important;
}
</style>